#JezMap BETA
#Written by Jeza
#Special thanks to Solii

counttime = 30
#Change the above to the amount of time (in seconds) required for the server to be empty before map change.

waittime = 60
#Change the above to the amount of time (in seconds) before checking player numbers after a map change (may be low due to client map downloads).

import es
import gamethread
from time import time
import random
fdir = (es.getAddonPath('jezmap') + '/maps.txt')
version = "BETA 101"

def load():
    es.msg("JezMap [" + version + "] addon loaded")
    es.set("jm_active","1")
    es.makepublic("jm_active")
    global count
    count = 0
    global newmap
    newmap = ""
    es.doblock("jezmap/check")

def getmaps():
    f = open(fdir, "r")
    maps = []
    linen = 0
    for line in f:
        linen += 1
        if str(line[0:2]) != "//": maps.append(line)
    
    length = len(maps)
    doing = 0
    while doing != length:
        y = maps[doing]
        ylen = len(y)-1
        if y[ylen] == "\n":
            y = y[0:ylen]
            maps[doing] = y
        doing += 1
    return maps

targetmap = getmaps()
es.msg(targetmap)

def unload():
    es.set("jm_active","0")
    es.msg("JezMap addon unloaded")

def player_disconnect(event_var):
    es.doblock("jezmap/check")

def es_map_start(event_var):
    es.msg("JezMap: Waiting " + str(waittime) + " seconds for players to load map.")
    gamethread.delayed(waittime, check)

def player_team(event_var):
    es.doblock("jezmap/check")

def check():
    players = es.getplayercount(2) + es.getplayercount(3)
    active = es.server_var['jm_active']
    global count
    if int(players) == 0 and int(count) == 0 and int(active) == 1:
        if str(es.server_var['eventscripts_currentmap']) not in targetmap:
            count = counttime
            random.seed(time())
            global newmap
            newmap = targetmap[random.randint(0,len(targetmap)-1)]
            es.doblock("jezmap/domap")

def domap():
    global newmap
    global count
    active = es.server_var['jm_active']
    players = es.getplayercount(2) + es.getplayercount(3)
    if count > 0 and int(active) == 1:
        if int(players) > 0:
            es.msg("JezMap: Player joined. Map change cancelled!")
            count = 0
        else:
            if count < 10:
                if count < 6: es.msg("JezMap: No players found. Changing map to " + str(newmap) + " in " + str(count) + " seconds.")
            else:
                if int(str(count)[1]) == 0 or int(str(count)[1]) == 5: es.msg("JezMap: No players found. Changing map to " + str(newmap) + " in " + str(count) + " seconds.")
            count -= 1
            gamethread.delayed(1, domap)
    elif int(players) == 0 and int(active) == 1: es.server.cmd("changelevel " + str(newmap))
    elif int(active) == 0:
        es.msg("JezMap: Map change cancelled via console.")
        count = 0

def server_cvar(event_var):
    if str(es.event_var['cvarname']) == "jm_active":
        if int(es.event_var['cvarvalue']) == 0:
            es.msg("JezMap is now in standby mode.")
        else: 
            es.msg("JezMap is no longer in standby mode.")
            es.doblock("jezmap/check")

    

    
